<?php
if (!defined('__TYPECHO_ROOT_DIR__')) {
	exit;
}

include 'source/skycaiji.class.php';
skycaiji::init(__TYPECHO_ROOT_DIR__,'../');
$params=skycaiji::get_params();
$installed=skycaiji::installed($params);//检测是否已安装
$langData=skycaiji::$lang;
$type=isset($_GET['type'])?$_GET['type']:'index';
if($installed){
	//已安装
	$skycaijiUrl=skycaiji::$cmsUrl.$params['path'];
	include 'header.php';
	include 'menu.php';
	
	include 'source/view/skycaiji.php';
}elseif($type=='index'){
	//参数设置
	if(empty($_POST)) {
		include 'header.php';
		include 'menu.php';
				
		include 'source/view/setting.php';
	} else {
		$return=array('success'=>false,'error'=>'');
		$params=isset($_POST['params'])?$_POST['params']:array();
		if(!preg_match('/^[a-z]+$/',$params['path'])){
			$return['error']=$langData['error_path'];
		}elseif(!preg_match('/^.{3,15}$/i', $params['user'])){
			$return['error']=$langData['error_user'];
		}elseif(!preg_match('/^[a-zA-Z0-9\!\@\#\$\%\^\&\*]{6,20}$/i', $params['pwd'])){
			$return['error']=$langData['error_pwd'];
		}elseif(!preg_match('/^[^\s]+\@([\w\-]+\.){1,}\w+$/i', $params['email'])){
			$return['error']=$langData['error_email'];
		}
		if(!empty($return['error'])){
			skycaiji::echo_json($return);
		}
		skycaiji::set_params($params);//保存参数
		$return['success']=true;
		skycaiji::echo_json($return);
	}
}elseif($type=='install'){
	//开始安装
	$opdo=isset($_GET['opdo'])?$_GET['opdo']:'';

	if(empty($opdo)){
		$skycaijiUrl=skycaiji::$cmsUrl.$params['path'];
		$downloaded=skycaiji::downloaded($params);

		include 'header.php';
		include 'menu.php';
		
		include 'source/view/install.php';
	}else{
		$SKYCAIJI_PATH=skycaiji::$cmsPath.$params['path'];//skycaiji目录
		$DOWN_PATH=skycaiji::$rootPath.'data/down/';//文件下载目录
		
		$eachSize=1024*500;//每块的大小
		$fileUrl='http://down.skycaiji.com/skycaiji.zip';
		
		if($opdo=='files'){
			$fileHeader=get_headers($fileUrl,true);//头信息
			$fileSize=$fileHeader['Content-Length'];//文件大小
			$list=array();
			$count=ceil($fileSize/$eachSize);//块数
			for($i=0;$i<$count;$i++){
				//切割成N份
				$list[$i]=array('id'=>$i+1,'start'=>$i*$eachSize,'end'=>($i+1)*$eachSize);
				if($list[$i]['end']>=$fileSize){
					$list[$i]['end']=$fileSize;
				}
				$list[$i]['end']-=1;//必须减1
			}
			skycaiji::echo_json(array('success'=>true,'size'=>$fileSize,'list'=>$list));
		}elseif($opdo=='down'){
			$fileSize=intval($_GET['size']);
			$startSize=intval($_GET['start_size']);
			$endSize=intval($_GET['end_size']);
			$id=intval($_GET['fileid']);
		
			$data=array('success'=>false);
			if(file_exists($DOWN_PATH.$id)&&file_get_contents($DOWN_PATH.$id)){
				//存在文件
				$data['success']=true;
			}else{
				$blockData=skycaiji::get_html($fileUrl,null,"{$startSize}-{$endSize}");//块数据
				$data=array('success'=>false);
				if(empty($blockData)){
					//下载失败
					$data['success']=false;
				}else{
					skycaiji::write_dir_file($DOWN_PATH.$id, $blockData);
					$data['success']=true;
				}
			}
			skycaiji::echo_json($data);
		}elseif($opdo=='bushu'){
			$fileSize=intval($_GET['size']);
			$count=ceil($fileSize/$eachSize);//块数
			$data=array('success'=>false);
			$is_end=true;//下载完了
			for($i=1;$i<=$count;$i++){
				//判断所有块文件都存在
				if(!file_exists($DOWN_PATH.$i)){
					$is_end=false;
					break;
				}
			}
			if($is_end){
				//下载完成了
				$data['success']=true;
				$allData='';
				for($i=1;$i<=$count;$i++){
					$allData.=file_get_contents($DOWN_PATH.$i);
				}
				skycaiji::write_dir_file($DOWN_PATH.'skycaiji.zip', $allData);

				try {
					$zipClass=new \ZipArchive();//实例化解压类
					if($zipClass->open($DOWN_PATH.'skycaiji.zip')===TRUE){
						$zipClass->extractTo($SKYCAIJI_PATH);
						$zipClass->close();//关闭处理的zip文件
					}else{
						$data['error']=$langData['error_zip'];
					}
				}catch(\Exception $ex){
					$data['error']=$langData['error_ziparchive'];
				}
				if(!empty($data['error'])){
					$data['error'].=str_replace(array('{down}','{sky}'),array($DOWN_PATH,$SKYCAIJI_PATH),$langData['error_zip_self']);
				}else{
					//解压成功，配置蓝天采集器
					$db=Typecho_Db::get()->getConfig();//系统数据库配置
					$db=$db[0]->__toString();
					$db=unserialize($db);
					
					if(is_array($db)&&!empty($db)){
						skycaiji::clear_dir($DOWN_PATH);//清空已下载的文件
						$data['db']=array(
							'db_type'  => 'mysql',
							'db_host'  => $db['host'],
							'db_port'  => $db['port'],
							'db_name'  => $db['database'],
							'db_pwd'   => $db['password'],
							'db_user'  => $db['user'],
							'db_prefix'  => 'skycaiji_',
	
							'user_name'=>$params['user'],
							'user_pwd'=>$params['pwd'],
							'user_repwd'=>$params['pwd'],
							'user_email'=>$params['email']
						);
					}else{
						$data['db']=array();
					}
				}
			}
			skycaiji::echo_json($data);
		}else{
			exit();
		}
	}
}
?>